// -*-C++-*-
//
// File:      DopeVector.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 16:47:44 MEST 2002

#ifndef DopeVector_h
#define DopeVector_h
#include <f90cxx.h>

/*
  Templated interface to F90 vectors of a particular type.

 */

template<typename T>
struct DopeVector : public Dope<T, 1 >
{
public:

  int length() const
  {
    return dim[0].extent;
  }

  int lbound() const
  {
    return dim[0].lower;
  }

  int ubound() const
  {
    return dim[0].lower+dim[0].extent-1;
  }

  T& operator[]( unsigned long idx ) const
  {
    return *(T*)((int)addr + (dim[0].mult*idx + offset));
  }

  int sizeOfType() const {
    return sizeof(T);
  }

private:
};

#endif

