#include "Dal.h"
#include "error.h"
#include <iostream>


#include "SasDalUtils.h"
#include "dal_utilities.h"
#include "DataSubspace.h"


#include<vector>


/******************************************************
*
*******************************************************/
bool LoadVectorFloatColumnData(const Table *table, 
                      const string& columnName, 
		      int &size, vector<float> &data);

bool LoadVectorDoubleColumnData(const Table *table, 
                      const string& columnName, 
		      int &size, vector<double> &data);
void loadData(string file, vector<double> &ra, vector<double> &dec);

/***********************************************************************
*
*
*
***********************************************************************/

template<class T>
void compareData(vector<T> & data1, vector<T> &data2, T tolerance)
{

    for(unsigned i = 0; i < min(data1.size(), data2.size()); i++)
    {
        if( abs(data1[i] - data2[i]) > tolerance)
        {
	    cout << i << ") " << data1[i] << " " << data2[i] << " diff=" << data1[i] - data2[i] << endl;

            Sas::fatal("Wrong data values in SRCLIST table-", " ");

        }

    }

}

vector<vector<int16> >  loadInt16Image(const string inSet, const char * name, int &nx, int &ny);
void checkEdgePixels( vector<vector<int16> > &qualityMap);




template<class kind>
void setBit(kind & value, int no)
{

    int l = sizeof(kind) * 8;
  
 
    value |= (1 << (no % l));


}
template<class kind>
void unsetBit(kind &value, int no)
{
    int l = sizeof(kind) * 8;
 
   
    value &= ~(1 << (no % l));


}
template<class kind>
bool bitSet(kind value, int no)
{

   int l = sizeof(value) * 8;
 

  return value& (1 << (no % l));

}






/******************************************************************
* Checks that the source quality-flags have been set correctly
* from the quality image
*
*
*******************************************************************/

int main()
{

    int nx = 0, ny = 0;
    vector<vector<int16> >  qualityImage = loadInt16Image("testimage.fits", 
                                                          "QUALITY", nx, ny);



    return 0;

}

/***********************************************************
*
*
*
*
**********************************************************/
void loadData(string file, vector<double> &ra, vector<double> &dec)
{
    DataSet *dataSet = dataSetServer->open( file, Dal::Read);

    if (!dataSet)
    {


    }    
 
    const Table *table = dataSet->table( "SRCLIST", Dal::Read);
    if( !table) {};

    /**********************************************************************
    *
    *
    **********************************************************************/
  
    int size = 0;

 
    if ( !LoadVectorDoubleColumnData( table, "RA_CORR", size, ra))
    {

    

    }

 
    if ( !LoadVectorDoubleColumnData( table, "DEC_CORR", size, dec))
    {

    

    }

}
/********************************************************
*
*
******************************************************/
bool LoadVectorFloatColumnData(const Table *table, 
                      const string& columnName, 
                      int &size, vector<float> &data)
{
     



  
  
    size = table->rows();
   
  
  
    if (table->hasColumn(columnName))
    { 
        const ColumnData *columnData = table->column(columnName)->data();
        if (!columnData) exit(0);
	

      
        float *xData = columnData->real32Data();
       


	for (int i=0; i< size; i++) 
        {
	  data.push_back( xData[i] ); 
	 
	}
     }
         
   
    return true;
};


/********************************************************
*
*
******************************************************/
bool LoadVectorDoubleColumnData(const Table *table, 
                      const string& columnName, 
                      int &size, vector<double> &data)
{
       
    size = table->rows();
   
  
  
    if (table->hasColumn(columnName))
    { 
        const ColumnData *columnData = table->column(columnName)->data();
        if (!columnData) exit(0);
	

      
        double *xData = columnData->real64Data();
       

	for (int i=0; i< size; i++) 
        {
	    data.push_back( xData[i] ); 
	 
	}
    }
         
   
    return true;
};


/*******************************************************
*
*
*******************************************************/


vector<vector<int16> >  loadInt16Image(const string inSet, const char * name, int &nx, int &ny)
{


    DataSet *set = dataSetServer->open(inSet, Dal::Read);
 


    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
    const Array* array = set->array(name);
 

    const ArrayData * arraydata = array->data();
    const int16 * theData = arraydata->int16Data();
 

    /*****************************************************************
    * Get the size of the image
    *****************************************************************/
 
    longVec size = array->size();
   



    nx = (int)size[1];
    ny = (int)size[0];


    vector< vector<int16> > image(nx); 


    for (int i = 0; i < nx; i++)
    {
        image[i].resize(ny); 
        for (int j = 0; j < ny; j++)
        {
            
	    image[i][j] = theData[i + (j * nx)];  
	 	
        }

  
    }


    delete arraydata;
   
    dataSetServer->close( set ); // Finished with the file

    return image;


}
